#include "Mat3f.h"

// Include memcpy (if you wish to use it):
#include <cstring>

Mat3f::Mat3f(){
    // Set all values to zero, except for the diagonal of the matrix:
    for(int i=0; i < 9; ++i){
        data[i] = i%4 == 0 ? 1.f : 0.f;
    }
}

Mat3f::Mat3f(const Vec3f axis1, const Vec3f axis2, const Vec3f axis3){
    // Copy the first axis to the first four float values of the data-array:
    memcpy(&data[0], &axis1.x, sizeof(float) * 3);

    // Copy the second axis to the next four float values of the data-array:
    memcpy(&data[3], &axis2.x, sizeof(float) * 3);

    // Copy the third axis to the next four float values of the data-array:
    memcpy(&data[6], &axis3.x, sizeof(float) * 3);
}

Mat3f::Mat3f(const float pData[9]){
    // Just copy all values of the given array into the data-array:
    memcpy(data, pData, sizeof(float) * 9);
}

Mat3f::Mat3f(const std::vector<float> pData){
    // Just copy the first 16 values of the given array into the data-array:
    memcpy(data, &pData[0], sizeof(float) * 9);
}

Mat3f Mat3f::operator*(const Mat3f m) const{
    float result[9];

    //TODO: Implementation of matrix multiplication where
    //       the result is stored in the result array defined
    //       above (see Mat3f.h for details).

    return Mat3f();
}

Vec3f Mat3f::operator*(const Vec3f v) const{
    float dest[3];

    // TODO: Implementation of matrix * vector multiplication
    //       where the result is stored in the result array
    //       defined above (see Mat4f.h for details).


    return Vec3f();
}
